# GrAnnoT

GrAnnoT is an annotation transfer tool for pangenome graphs. It can transfer genome annotations to a pangenome graph containing the genome, and also transfer the pangenome graph's annotations on the genomes it contains. 
This project is young and in development, some errors will be corrected, improvements will be made and new features will appear in the near future.

## Usage
GrAnnoT requires the graph to be in GFA format with W-lines that describe the walks of the input genomes. For example minigraph-cactus gives that kind of output. 

You first need to extract from the GFA the positions of the segments of the graph on the genomes it contains. For this you need to run the script getSegmentsCoordinates.py with the GFA file as input. 
Then you will need to run the following command using the segments coordinates on the reference genome (for the annotation), and the annotation file in GFF/GTF format : 
```
bedtools intersect -wo -a segmentsCoordinatesOnReferenceGenome.bed -b annotationFile.gff > intersectFile.bed
```

You can then finally run GrAnnoT itself via the script main.py with the following arguments : 
- intersect file
- GFA file  with walks
- bed file with coordinates of the segments on the target genome
- the name of the target genome path in the GFA file.

It will output the following files :
- a GFF and a GAF file with the annotation of the graph
- the GFF file with the annotation of the target genome
- a text file with the details of the variations within the annotated regions.



### Support
If you have any question or suggestion, feel free to contact me by email : nina.marthe@ird.fr

### Authors
If you use this program please cite Nina Marthe, Francois Sabot and Matthias Zytnicki.






MIT License


